! FUNCTION THAT RETURNS A NORMALLY DISTRIBUTED DEVIATE WITH ZERO MEAN AND STANDARD DEVIATION
! SPECIFIED BY ARGUMENT 'SIGMA' AND RANDOM SEED 'IDUM'
! BASED ON CODE ON PG. 280 OF PRESS ET AL.
! 5/9/00 BY JCL
!
! $Id: gasdev.f90,v 1.1 2005/09/27 13:39:33 trn Exp $
!
      FUNCTION GASDEV(IDUM,SIGMA)
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER IDUM
      REAL*8 GASDEV
      REAL*8 SIGMA

      INTEGER ISET
      REAL*8 FAC,GSET,RSQ,V1,V2
      REAL*8 RAN3
      SAVE ISET,GSET
      DATA ISET/0/

!     WE DON'T HAVE AN EXTRA DEVIATE HANDY, SO PICK 2 UNIFORM NUMBERS IN THE SQUARE EXTENDING
!     FROM -1 TO +1 IN EACH DIRECTION, SEE IF THEY ARE IN THE UNIT CIRCLE, AND IF THEY ARE
!     NOT, TRY AGAIN.
      IF (ISET.EQ.0)THEN
!    1    V1=2.0*0.825-1.0
!         V2=2.0*0.825-1.0
    1    V1=2.0*RAN3(IDUM)-1.0
         V2=2.0*RAN3(IDUM)-1.0
! JCL:   REMOVE THE EXPONENT EXPRESSION--MULTIPLICATION PROBABLY FASTER THAN EXPONENT
         RSQ=V1*V1+V2*V2
!         RSQ=V1**2+V2**2
         IF(RSQ.GE.1.0.OR.RSQ.EQ.0.0)GOTO 1
!        NOW MAKE THE BOX-MULLER TRANSFORMATION TO GET TWO NORMAL DEVIATES.
!        RETURN ONE AND SAVE THE OTHER FOR NEXT TIME.
         FAC=DSQRT(-2.0*DLOG(RSQ)/RSQ)
         GSET=V1*FAC
         GASDEV=V2*FAC
!        SET FLAG
         ISET=1
      ELSE
!        WE HAVE AN EXTRA DEVIATE HANDY, SO RETURN IT, AND UNSET THE FLAG
         GASDEV=GSET
         ISET=0
      END IF
!     SCALE RETURN VALUE WITH THE DESIRED SIGMA VALUE
      GASDEV=SIGMA*GASDEV
      RETURN
      END
